// If this code works, it was written by Svetlio Kapralov. If not, I don't know who wrote it.
package net.playerfinder.jsf.components.inputtextarea;

import javax.faces.application.ResourceDependencies;
import javax.faces.application.ResourceDependency;
import javax.faces.component.FacesComponent;
import javax.faces.component.html.HtmlInputTextarea;

@FacesComponent(UIInputTextArea.COMPONENT_TYPE)
@ResourceDependencies({
		@ResourceDependency(name = "jquery.js", library = "pfjs"),
		@ResourceDependency(name = "pf.no.conflicts.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.autoresize.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.color.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.prompttext.js", library = "pfjs") })
public class UIInputTextArea extends HtmlInputTextarea  {

	public static final String COMPONENT_TYPE = "net.playerfinder.jsf.components.inputtextarea.UIInputTextArea";
	public static final String COMPONENT_FAMILY = "net.playerfinder.jsf.components";
	public static final String DEFAULT_RENDERER = "net.playerfinder.jsf.components.inputtextarea.UIInputTextAreaRenderer";

	protected enum PropertyKeys {
		promptText, promptColor, animate, animateDuration, extraSpace, minHeight, maxHeight;

		String toString;

		PropertyKeys(String toString) {
			this.toString = toString;
		}

		PropertyKeys() {
		}

		public String toString() {
			return ((this.toString != null) ? this.toString : super.toString());
		}
	}

	public UIInputTextArea() {
		setRendererType(DEFAULT_RENDERER);
	}

	@Override
	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	public boolean isAnimate() {
		return (Boolean) getStateHelper().eval(PropertyKeys.animate, false);
	}

	public void setAnimate(boolean autoResize) {
		getStateHelper().put(PropertyKeys.animate, autoResize);
	}

	public Integer getMinHeight() {
		return (Integer) getStateHelper().eval(PropertyKeys.minHeight, 0);
	}

	public void setMinHeight(Integer minHeight) {
		getStateHelper().put(PropertyKeys.minHeight, minHeight);
	}
	
	public Integer getMaxHeight() {
		return (Integer) getStateHelper().eval(PropertyKeys.maxHeight, 500);
	}

	public void setMaxHeight(Integer maxHeight) {
		getStateHelper().put(PropertyKeys.maxHeight, maxHeight);
	}

	public String getPromptText() {
		return (String) getStateHelper().eval(PropertyKeys.promptText, "");
	}

	public void setPromptText(String promptText) {
		getStateHelper().put(PropertyKeys.promptText, promptText);
	}

	public String getPromptColor() {
		return (String) getStateHelper().eval(PropertyKeys.promptColor,
				"#999999");
	}

	public void setPromptColor(String promptColor) {
		getStateHelper().put(PropertyKeys.promptColor, promptColor);
	}

	public int getAnimateDuration() {
		return (Integer) getStateHelper().eval(PropertyKeys.animateDuration,
				200);
	}

	public void setAffectDuration(int animateDuration) {
		getStateHelper().put(PropertyKeys.animateDuration, animateDuration);
	}

	public int getExtraSpace() {
		return (Integer) getStateHelper().eval(PropertyKeys.extraSpace, 10);
	}

	public void setExtraSpace(int extraSpace) {
		getStateHelper().put(PropertyKeys.extraSpace, extraSpace);
	}

}
